/* Answers/PublishSubscribe/Base/EvenOdd/EvenOddAllExample.p*/
/* Copyright 2011-2015 TDK Consulting Services Inc.         */
/* Timothy D. Kuehn - tim.kuehn@gmail.com                   */

USING Answers.PublishSubscribe.Base.EvenOdd.*. 

DEFINE VARIABLE oGenerateEvents AS GenerateEvents   NO-UNDO.

DEFINE VARIABLE oEvenCount      AS CountEvents      NO-UNDO.
DEFINE VARIABLE oOddCount       AS CountEvents      NO-UNDO.
DEFINE VARIABLE oAllCount       AS CountEvents      NO-UNDO.

DEFINE VARIABLE oSaveCount      AS SaveEvent        NO-UNDO.

oGenerateEvents = NEW GenerateEvents().

oEvenCount      = NEW CountEvents().
oOddCount       = NEW CountEvents().

oAllCount       = NEW CountEvents().
oSaveCount      = NEW SaveEvent().

oGenerateEvents:EvenEvent:Subscribe(oEvenCount:CountEvent). 
oGenerateEvents:OddEvent:Subscribe(oOddCount:CountEvent). 

oGenerateEvents:EvenEvent:Subscribe(oAllCount:CountEvent). 
oGenerateEvents:OddEvent:Subscribe(oAllCount:CountEvent). 

oGenerateEvents:EventCount:Subscribe(oSaveCount:SaveEventCount).

oGenerateEvents:Generate().

MESSAGE "Even"  oEvenCount:EventCount   SKIP 
        "Odd"   oOddCount:EventCount    SKIP 
        "All"   oAllCount:EventCount    SKIP 
        "Total" oSaveCount:EventCountTotal
   VIEW-AS ALERT-BOX. 
