/* Answers/PublishSubscribe/Base/Train/Camera.cls       */
/* Presentation 2011-2015 TDK Consulting Services Inc.  */
/* Timothy D. Kuehn - tim.kuehn@gmail.com               */

CLASS Answers.PublishSubscribe.Base.Train.Camera: 

DEFINE PUBLIC PROPERTY PictureCount AS INTEGER NO-UNDO GET. PRIVATE SET. 

DEFINE PUBLIC EVENT ActivateShutter SIGNATURE VOID (chSound AS CHARACTER).
DEFINE PUBLIC EVENT NotifyUser      SIGNATURE VOID (chNotifcation AS CHARACTER).

METHOD PUBLIC VOID TakePicture():
    
IF THIS-OBJECT:PictureCount < 5 THEN 
    DO:
    THIS-OBJECT:PictureCount = THIS-OBJECT:PictureCount + 1.
    THIS-OBJECT:ActivateShutter:Publish("Snap " + STRING(THIS-OBJECT:PictureCount)).
    END.
ELSE 
    THIS-OBJECT:NotifyUser:Publish("Camera Full.").

END METHOD.

END CLASS.