/* Answers/PublishSubscribe/Base/Train/TrainWatchingExample.p   */
/* Copyright 2011-2015 TDK Consulting Services Inc.     */
/* Timothy D. Kuehn - tim.kuehn@gmail.com               */

USING Answers.PublishSubscribe.Base.Train.*.

DEFINE VARIABLE oEngine     AS Engine    NO-UNDO.
DEFINE VARIABLE oRailFan    AS RailFan  NO-UNDO.
DEFINE VARIABLE oCamera     AS Camera   NO-UNDO.

PAUSE 0 BEFORE-HIDE.

    /* Create the objects   */
    
oEngine     = NEW Engine().
oRailFan    = NEW RailFan().
oCamera     = NEW Camera().

    /* Connect everything   */
    
oEngine:Whistle:Subscribe(oRailFan:Listen).
oEngine:TrainBell:Subscribe(oRailFan:Listen). 

oRailFan:TakePicture:Subscribe(oCamera:TakePicture).

oCamera:ActivateShutter:Subscribe(oRailFan:Listen).
oCamera:NotifyUser:Subscribe(oRailFan:Watch).

    /* Do the work          */
    
oEngine:DriveTrain().

