/* Answers/PublishSubscribe/Base/EvenOdd/GenerateEvents.cls */
/* Copyright 2011-2015 TDK Consulting Services Inc.         */
/* Timothy D. Kuehn - tim.kuehn@gmail.com                   */

CLASS Answers.PublishSubscribe.Base.EvenOdd.GenerateEvents: 

DEFINE PUBLIC EVENT EventCount      SIGNATURE VOID (iEventCount AS INTEGER).
DEFINE PUBLIC EVENT EvenEvent       SIGNATURE VOID ().
DEFINE PUBLIC EVENT OddEvent        SIGNATURE VOID ().

METHOD PUBLIC VOID Generate():
DEFINE VARIABLE iEventNumber        AS INTEGER NO-UNDO.
DEFINE VARIABLE iFinal              AS INTEGER NO-UNDO.

ASSIGN iFinal = RANDOM(1000, 2000).
  
DO iEventNumber = 1 TO iFinal:

    IF INTEGER(iEventNumber / 2) * 2 = iEventNumber THEN 
        THIS-OBJECT:EvenEvent:PUBLISH().
    ELSE 
        THIS-OBJECT:OddEvent:PUBLISH().    
END.

THIS-OBJECT:EventCount:PUBLISH(iEventNumber - 1).

END METHOD.

END CLASS.